/********************************************************************
 *                                                                  *
 * cam4.c         5-SEP-1991             Y.Takeuchi                 *
 *                                                                  *
 * original: camtest5.c on OS9 by M.Nomachi                         *
 *                                                                  *
 * CAMAC list proccessing test program                              *
 * SPARC  SFVME-100                                                 *
 ********************************************************************/
#include    <stdio.h>
#include    <string.h>
#include    "camlib.h"

#define D_size     20240
#define L_size     1024
#define DEFNAME    "cam4.obj"
#define DEFS       100


main(argc, argv)
int argc;
char *argv[];
{
    unsigned short list[L_size];
    int data[D_size];
    unsigned short *usp = (unsigned short *)data;
    struct cc_iosb iosb;
    register int status;
    int i, s, list_length;
    char filename[33];

/* read options */
    strcpy(filename, (argc > 1) ? argv[1] : DEFNAME);
    s = (argc > 2) ? atoi(argv[2]) : DEFS;

/* Initialize data buffer */    
    for(i = 0; i < D_size; i++)
        usp[i] = 0;


/* Open */
    status = CAM_Open();
    if (status) {
	printf("Open error!\n");
        exit(status);
    }

/* read camac list */
    status = CamReaLIST(filename, list, L_size, &list_length, &i);
    printf(" list length = %d\n", list_length);
    if (status) {
	printf("Read list error!\n");
        exit(status);
    }

/* install the list */
    status = CamLisLOAD(list, list_length, &i);
    if (status) {
	printf("Load list error!\n");
        exit(status);
    }

/* set S register initial value */
    iosb.s_reg = s;
    printf(" S = %d\n", iosb.s_reg);

/* Execute */
    printf(" Now execute %s ...\n", filename);
    status = CamExeWAIt(data, D_size, &iosb);
    printf("\n");
    printf(" CAMEXE status = %x\n", status);
    printf(" IOSB status = 0x%x, n word = %d, S = %d\n",
	   iosb.status, iosb.ret_length, iosb.s_reg);
    if (status) {

	perror("ERROR");
	printf("Execute list error!  status = %d\n", status);
        exit(status);
    }

/* Dump buffer */
/*
    printf("\n");
    for(i = 0; i < s / 2; i++)
        printf("data[%3d]=0x%8x %10u  usp[%3d]=0x%4x %5d  usp[%3d]=0x%4x %5d\n",
	       i, data[i], data[i], i*2, usp[i*2], usp[i*2], i*2+1, usp[i*2+1], usp[i*2+1]);
    printf("\n");
*/
/* Close */
    CAM_Close(1);

    return 0;
}
